# coding: utf-8

"""
    FreeChat OpenAPI Definition

    https://github.com/freechat-fun/freechat

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
from freechat-sdk.models.character_info_draft_dto import CharacterInfoDraftDTO
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CharacterUpdateDTO(BaseModel):
    """
    Request data for updating character information
    """ # noqa: E501
    parent_id: Optional[StrictStr] = Field(default=None, description="Referenced character", alias="parentId")
    visibility: Optional[StrictStr] = Field(default=None, description="Visibility: private (default), public, public_org, hidden")
    name: StrictStr = Field(description="Character name")
    description: Optional[StrictStr] = Field(default=None, description="Character description")
    avatar: Optional[StrictStr] = Field(default=None, description="Character avatar url")
    picture: Optional[StrictStr] = Field(default=None, description="Character picture url")
    gender: Optional[StrictStr] = Field(default=None, description="Character gender: male | female | non_human | unknown")
    profile: Optional[StrictStr] = Field(default=None, description="Character profile")
    greeting: Optional[StrictStr] = Field(default=None, description="Character greeting")
    chat_style: Optional[StrictStr] = Field(default=None, description="Character chat-style", alias="chatStyle")
    chat_example: Optional[StrictStr] = Field(default=None, description="Character chat-example", alias="chatExample")
    experience: Optional[StrictStr] = Field(default=None, description="Character experience")
    lang: Optional[StrictStr] = Field(default=None, description="Character language: English | Chinese (Simplified) | ...")
    ext: Optional[StrictStr] = Field(default=None, description="Additional information, JSON format")
    draft: Optional[CharacterInfoDraftDTO] = None
    tags: Optional[List[StrictStr]] = Field(default=None, description="Tag set")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["parentId", "visibility", "name", "description", "avatar", "picture", "gender", "profile", "greeting", "chatStyle", "chatExample", "experience", "lang", "ext", "draft", "tags"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CharacterUpdateDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
                "additional_properties",
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of draft
        if self.draft:
            _dict['draft'] = self.draft.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CharacterUpdateDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "parentId": obj.get("parentId"),
            "visibility": obj.get("visibility"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "avatar": obj.get("avatar"),
            "picture": obj.get("picture"),
            "gender": obj.get("gender"),
            "profile": obj.get("profile"),
            "greeting": obj.get("greeting"),
            "chatStyle": obj.get("chatStyle"),
            "chatExample": obj.get("chatExample"),
            "experience": obj.get("experience"),
            "lang": obj.get("lang"),
            "ext": obj.get("ext"),
            "draft": CharacterInfoDraftDTO.from_dict(obj.get("draft")) if obj.get("draft") is not None else None,
            "tags": obj.get("tags")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


